<?php
/**
 * @license GNU/GPLv3
 * @author ChatSupport <team@chatsupport.co>
 */
defined('JPATH_BASE') or die;
use Joomla\CMS\Uri\Uri;

jimport('joomla.form.formfield');

class JFormFieldCslogin extends JFormField
{
    protected $type = 'scripts';
    protected function getLabel()
    {
		return '<p id="chatsupport_account-lbl"></p>';
    }

    protected function getInput()
    {
        $cs_widgetId = $this->form->getValue('chatsupport_widgetId', 'params');
        $cs_widget_theme_color = $this->form->getValue('chatsupport_widgetThemeColor', 'params');
        $cs_logo_url = $this->form->getValue('chatsupport_logoUrl', 'params');
        $cs_widget_name = $this->form->getValue('chatsupport_widgetName', 'params');
        $cs_widget_domain = $this->form->getValue('chatsupport_widgetDomain', 'params');		
        $siteUrl =  Uri::root();

        $html = '
		<div id="chatsupport-login-container" class="move-left">
			<section id="connect-widget-setup" class="joomla-plugin-setup display-none" style="display: inline-block;">
      <div>
      <img src= "'.$siteUrl.'plugins/system/chatsupport/assets/images/joomla_logo.png"><img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/link-icon.svg"><img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/chatsupport-logo.svg">      </div>
      <img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/template-icon.png">      <button class="btn-progressing" style="display:none"><span>Connect to ChatSupport</span></button>
      <input type="button" id="cwa-login" siteUrl= "'.$siteUrl.'" value="Connect to ChatSupport" style="display: block;">
  </section>
			<section id="multiple-widget-setup" class="widget-install display-none" style="display: block;">
      <img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/chatsupport-logo.svg">      <h3>Install your widget</h3>
      <h4>Select one of your active widgets to install it.</h4>
      <section class="joomla-project-clips"></section>
	  </section>
	  <section id="single-widget-setup" class="widget-install display-none" style="display: block;">
    <img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/chatsupport-logo.svg">    <h3>Widget Installed</h3>
    <h4>Your widget has been installed</h4>
  <section class="joomla-project-clips">
    <aside>
    </aside>
  </section>
  <button id="preview-widget" onclick="window.open(&quot;'.$siteUrl.'&quot;)"><span>Visit your site</span></button>
  <button class="btn-outline" onclick="window.open(&quot;https://app.chatsupport.co/app/'.substr($cs_widgetId,3).'/settings/widget/configuration&quot;)">Customise widget</button>
  </section>
<div class="joomla-loader" style="display: none;">
    <svg width="32px" height="34px" viewBox="0 0 32 34" version="1.1" xmlns="http://www.w3.org/2000/svg">
        <g stroke-linecap="round">
            <g transform="translate(-64.000000, -38.000000)">
                <path d="M80,71 L80,71 C82.1693626,71 84.2378875,70.5682622 86.124339,69.786022 C88.0799687,68.9750963 89.8399266,67.7874904 91.3137085,66.3137085 C92.7874904,64.8399266 93.9750963,63.0799687 94.786022,61.124339 M80,39 C75.581722,39 71.581722,40.790861 68.6862915,43.6862915 C67.2125096,45.1600734 66.0249037,46.9200313 65.213978,48.875661"></path>
            </g>
        </g>
    </svg>
  </div>
  <div class="bg" style="display:none;"></div>
  <div class="joomla-bg" style="display: none;"></div>
  <div class="joomla-error" style="display: none;">
    <img src="'.$siteUrl.'plugins/system/chatsupport/assets/images/cloud.svg">    <h2>Unknown error occured</h2>    
    <input type="button" id="error-frame" value="Retry" style="width: 100px">
</div>
		</div>
		' . $html_acc;
		

        return $html;
    }
}
