<?php
/**
 * @license GNU/GPLv3
 * @author ChatSupport <team@chatsupport.co>
 */

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

class JFormFieldScripts extends JFormField
{
    protected $type = 'scripts';
    protected function getLabel()
    {
        return '';
    }

    protected function getInput()
    {
        JHtml::_('jquery.framework', true);
        $document = JFactory::getDocument();
        $document->addStyleSheet(JURI::root(true) . '/plugins/system/chatsupport/assets/css/chatsupport.css');
        $document->addScript(JURI::root(true) . '/plugins/system/chatsupport/assets/js/chatsupport.js');
        return;
    }
}